\section{Soft Constraint Programming with MiniBrass}

\subsection{MiniZinc}
\begin{frame}[fragile]{MiniZinc}
	\begin{lstlisting}[language=minizinc, gobble=4]
		set of int: myDomain = 1..2;
		var myDomain: x; var myDomain: y;
		constraint x != y;
		solve @\alt<3>{\alert<3>{minimize x}}{satisfy}@;
	\end{lstlisting}
	\onslide<2->{\begin{center}
		\begin{tikzpicture}[->]
			\node (s1) at (-3, -1) {$x = 1 \land y = 2$};
			\node (s2) [cross out, draw on=<2>, color=fg] at (3, -1) {$x = 2 \land y = 1$};
			\draw (-2, 0) -> (s1);
			\draw (2, 0) -> (s2);
		\end{tikzpicture}
	\end{center}}
\end{frame}

\subsection{MiniBrass}
\begin{frame}[fragile]{MiniBrass}
	\begin{center}
		\begin{lstlisting}[language=minizinc, gobble=6]
			set of int: myDomain = 1..2;
			var myDomain: x; var myDomain: y;
			constraint x != y;
		\end{lstlisting}
		\pause
		\begin{lstlisting}[language=minibrass, gobble=6]
			PVS: prefer2 = new WeightedCsp("prefer2") {
			 soft-constraint x2: 'x == 2' :: weights('1');
			 soft-constraint y2: 'y == 2' :: weights('2');
			};
			solve prefer2;
		\end{lstlisting}
	\pause
		\begin{tikzpicture}[->]
			\centering
			\node (s1) at (0, -1) {$x = 1 \land y = 2$};
			\draw (0, 0) -> (s1);
		\end{tikzpicture}
	\end{center}
\end{frame}